#pragma once

#include "EasyBMP/EasyBMP.h"
#include <time.h>
#include <random>
#include <string>


class MazeGenerator
{
public:
	MazeGenerator();
	~MazeGenerator();

	std::string generate(int size, std::string filename);

private:

	enum Direction
	{
		INVALID = 0,
		NORTH = 1,
		EAST = 2,
		SOUTH = 4,
		WEST = 8
	};

	static const int DIRECTION_X[9];
	static const int DIRECTION_Y[9];
	static const int MASK[9];
	
	int numberOfCells_;
	int cellSize_;
	int imageSize_;

	int idX_;
	int idY_;

	unsigned char* maze_;

	RGBApixel backgroundColor_;
	RGBApixel mazeColor_;


	int getCellId() { return idX_ + numberOfCells_ * idY_; }

	int getRandomInt() { return std::rand() % numberOfCells_; }

	int getRandomInt4() { return std::rand() % 4; }



	bool isDirectionValid(const Direction& dir);
	
	Direction getDirection();
	
	void generateMaze();

	void setColor(RGBApixel& pixel, const int& r, const int& g, const int& b);


	
	void drawBackground(BMP& image);
	void drawLine(BMP& image, const int& x1, const int& y1, const int& x2, const int& y2);
	void drawMaze(BMP& image);


};

